%  Program: progSA2.m
%  Description: Implements the method of finding the minimizer
%  described in the solution of Prob.SA.2.
%  Output:
%     c_star: optimum value of constant c
%     x_star: minimizer of the problem
%  To Run: Type (or copy-and-paste) progSA2 in the command line 
%  and press Enter.
%  ==============================================================
disp(' ')
disp('Program progSA2.m')
cl = 3; 
cu = 5;
d = cu - cl;
while d > 1e-12,
   c = 0.5*(cl+cu);
   rts = roots([4 -32 105-8*c 32*c-236 352+4*c^2-32*c]);
   im1 = imag(rts(1));
   im2 = imag(rts(3));
   if im1*im2 ~= 0,
      cl = c;
   else 
      cu = c;
   end
  d = d/2;
end
format long
disp('Optimum value of c:')
c_star = (cl+cu)/2
rts = roots([4 -32 105-8*c 32*c-236 352+4*c^2-32*c]);
irw = imag(rts(1));
k = 1;
while irw > 1e-6,
    irw = imag(rts(k));
    k = k + 1;
end
x1 = real(rts(k));
x2 = c - (x1 - 2)^2;
disp('Minimizer:')
x_star = [x1 x2]'
clear ans c cu cl d im1 im2 rts irw k x1 x2
format short