%  Program: progSA5a.m
%  Description: Generates a 3-dimensional plot for function
%     f(x) = 0.6*x2^4 + 5*x1^2 - 7*x2^2 + sin(x1*x2) - 5*x2
%  over the range -pi <= x1, x2 <= pi.
%  Output:
%     x1, x2: the two x-axes, each is a vector of 101 components
%          f: a matrix of size 101 x 101 which gives the values 
%             of above function f(x) over the grid points 
%             specified by (x1,x2).
%  To Run: Execute the command progSA5a.
%  =============================================================
disp(' ')
disp('Program progSA5a.m')
x1 = -pi:(2*pi)/100:pi; 
x1 = x1(:)'; 
x2 = pi:(-2*pi)/100:-pi; 
x2 = x2(:); 
e = ones(101,1);
f = 0.6*(x2.^4)*e' + 5*e*(x1.^2) - 7*(x2.^2)*e'+ sin(x2*x1) - 5*x2*e';
figure(1)
meshc(x1,x2,f)
axis([-pi pi -pi pi -50 100])
xlabel('\itx_1','FontName','Times','FontSize',13)
ylabel('\itx_2','FontName','Times','FontSize',13)
clear e