%  Program: progSA8b2.m
%  Description: Evaluates the gradient of the objective function
%  f(x) = (x1-4*x2)^4 + 12*(x3-x4)^4 + 3*(x2-10*x3)^2 + 55*(x1-2*x4)^2
%  for Prob.SA.8.
%  Input:
%      x: a 4-component point as a column vector
%  Output:
%      g: gradient of f(x) at point x.
%  To Run: Execute the commands:
%    x = [x1 x2 x3 x4]' % e.g., x = [1 2 3 4]'
%    g = progSA8b2(x)
%  ===================================================================
function g = progSA8b2(x)
x1 = x(1);
x2 = x(2);
x3 = x(3);
x4 = x(4);
a1 = x1 - 4*x2;
a2 = x1 - 2*x4;
a3 = x2 - 10*x3;
a4 = x3 - x4;
g1 = 4*a1^3 + 110*a2;
g2 = -16*a1^3 + 6*a3;
g3 = 48*a4^3 - 60*a3;
g4 = -48*a4^3 - 220*a2;
g = [g1 g2 g3 g4]';