%  Program: progSA8c2.m
%  Description: Evaluates the Jacobian of 
%  [f1(x) f2(x) f3(x) f4(x)]' where
%         f1(x) = (x1 - 4*x2)^2
%         f2(x) = sqrt(12)*(x3 - x4)^2
%         f3(x) = sqrt(3)*(x2 - 10*x3)
%         f4(x) = sqrt(55)*(10*(x1 - 2*x4)
%  for Prob.SA.8c.
%  Theory: See Practical Optimization, Sec. 5.4.
%  Input:
%     x: a 4-component point as a column vector
%  Output:
%     J: Jacobian of [f1(x) f2(x) f3(x) f4(x)]'.
%  To Run: Execute the commands:
%    x = [x1 x2 x3 x4]' % e.g., x = [1 2 3 4]'
%    J = progSA8c2(x)
%  =============================================
function J = progSA8c2(x)
x1 = x(1);
x2 = x(2);
x3 = x(3);
x4 = x(4);
s1 = 2*sqrt(12);
s3 = sqrt(3);
s5 = sqrt(55);
a1 = x1 - 4*x2;
a2 = x3 - x4;
J1 = [2*a1 -8*a1 0 0];
J2 = [0 0 s1*a2 -s1*a2];
J3 = [0 s3 -10*s3 0];
J4 = [s5 0 0 -2*s5];
J = [J1; J2; J3; J4];